---
title: Patch User Roles
slug: api-documentation/patch-user-roles
docTags: 
createdAt: 2026-08-27T16:18:26.773Z
---

{
  "id": "loQrq200UVwP5BK2U4yyX",
  "type": "api-oas-v2",
  "data": {
    "method": "PATCH",
    "url": "https://api.upstartcommerce.com/v1/users/user-roles",
    "servers": [
      {
        "url": "https://api.upstartcommerce.com/v1/users/user-roles"
      }
    ],
    "name": "Patch User Roles",
    "description": "<p>This endpoint allows for an admin to add roles to all specified users. It may be useful when a new site is added to a tenant, and all existing users' permissions have to be updated accordingly. Note that this endpoint can only add roles, not modify or delete existing roles.</p>\n<p>Authorized system roles:</p>\n<ul>\n<li><code>system.admin</code></li>\n<li><code>user.mgmt</code></li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "The users to update and the role assignments to apply to them.",
          "customType": "UserRolesRequest",
          "schema": [
            {
              "name": "userIds",
              "kind": "required",
              "type": "array",
              "description": "A list of user ids.",
              "example": "",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            },
            {
              "name": "userRoles",
              "kind": "required",
              "type": "object",
              "description": "<p>A map indexed by a tenant name listing all tenant-level roles and site-level roles.\nFor example:\n{\n\"tenant1\" : {\n\"roleIds\" : [\"some.role1\",\"some.role2\"],\nsites: {\n\"site1\": {\n\"roleIds\": [\"some.role3\",\"some.role4\"]\n},\n\"site2\": {\n\"roleIds\": [\"some.role4\",\"some.role6\"]\n}\n}\n},\n\"tenant2\" : {\n\"roleIds\" : [\"some.other.role1\",\"some.other.role2\"],\nsites: {\n\"site1\": {\n\"roleIds\": [\"some.other.role3\",\"some.other.role4\"]\n},\n\"site2\": {\n\"roleIds\": [\"some.other.role5\",\"some.other.role6\"]\n}\n}\n}\n}</p>",
              "example": "{\"tenant-name-1\":{\"roleIds\":[\"catalog.mgmt\"],\"sites\":{\"example-site-name-1\":{\"roleIds\":[\"order.mgmt\"]},\"example-site-name-2\":{\"roleIds\":[\"order.mgmt\"]}}},\"tenant-name-2\":{\"roleIds\":[\"user.mgmt\"],\"sites\":{\"example-site-name-1\":{\"roleIds\":[]},\"example-site-name-2\":{\"roleIds\":[\"inventory.mgmt\"]}}}}",
              "modelRef": "#/components/schemas/UserRoles",
              "customType": "UserRoles",
              "schema": []
            }
          ],
          "modelRef": "#/components/schemas/UserRolesRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "SessionIdAccess",
          "name": "X-Upstart-Session-Id",
          "kind": "optional",
          "type": "apiKey",
          "description": "<p>Session based authorization. This authentication is required for clients to interact with any of the management APIs. Similar to ''LoggedIn'', it indicates that the user has actually logged into the system, but in this case with a management role.</p>",
          "in": "header"
        },
        {
          "id": "ApiKeyAccess",
          "name": "X-Upstart-Api-Key",
          "kind": "optional",
          "type": "apiKey",
          "description": "Api key based authorization.",
          "in": "header"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "All users' roles have been successfully updated.",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "400",
        "description": "The request contained information that the server was unable to process. Appropriate errors are provided in the response body.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "Details of a request that failed validation.",
            "customType": "ValidationErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ValidationErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>Credentials are missing, expired or insufficient (HTTP 401).</p>",
            "customType": "UnauthorizedError",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/UnauthorizedError",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "403",
        "description": "<p>An update to this resource requires the if-match and if-unmodified-since headers to be sent in order to process the request.</p>",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>The request is understood but refused (HTTP 403).</p>",
            "customType": "ForbiddenError",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ForbiddenError",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "404",
        "description": "The requested resource was not found in the NoChannel system.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>The addressed resource does not exist (HTTP 404).</p>",
            "customType": "NotFoundError",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/NotFoundError",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "409",
        "description": "The request conflicts with the current state of the resource.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>The request conflicts with existing state (HTTP 409).</p>",
            "customType": "ConflictError",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ConflictError",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "500",
        "description": "Internal server error. The server encountered an unexpected condition that prevented it from fulfilling the request.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>The request failed for an unexpected reason (HTTP 500).</p>",
            "customType": "InternalServerError",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/InternalServerError",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "ZtWloQNEPoivn4N61lGxl",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request PATCH \\\n     --url https://api.upstartcommerce.com/v1/users/user-roles \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '{\n     \"userIds\": [],\n     \"userRoles\": \"{\\\"tenant-name-1\\\":{\\\"roleIds\\\":[\\\"catalog.mgmt\\\"],\\\"sites\\\":{\\\"example-site-name-1\\\":{\\\"roleIds\\\":[\\\"order.mgmt\\\"]},\\\"example-site-name-2\\\":{\\\"roleIds\\\":[\\\"order.mgmt\\\"]}}},\\\"tenant-name-2\\\":{\\\"roleIds\\\":[\\\"user.mgmt\\\"],\\\"sites\\\":{\\\"example-site-name-1\\\":{\\\"roleIds\\\":[]},\\\"example-site-name-2\\\":{\\\"roleIds\\\":[\\\"inventory.mgmt\\\"]}}}}\"\n     }'"
        },
        {
          "id": "5DfQhQzwCiV_N7e3AHZU4",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify({\n   \"userIds\": [],\n   \"userRoles\": \"{\\\"tenant-name-1\\\":{\\\"roleIds\\\":[\\\"catalog.mgmt\\\"],\\\"sites\\\":{\\\"example-site-name-1\\\":{\\\"roleIds\\\":[\\\"order.mgmt\\\"]},\\\"example-site-name-2\\\":{\\\"roleIds\\\":[\\\"order.mgmt\\\"]}}},\\\"tenant-name-2\\\":{\\\"roleIds\\\":[\\\"user.mgmt\\\"],\\\"sites\\\":{\\\"example-site-name-1\\\":{\\\"roleIds\\\":[]},\\\"example-site-name-2\\\":{\\\"roleIds\\\":[\\\"inventory.mgmt\\\"]}}}}\"\n});\n\nvar requestOptions = {\n   method: 'PATCH',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.upstartcommerce.com/v1/users/user-roles\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "yCKVkc2ipXV6jPW2LpKiA",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.upstartcommerce.com/v1/users/user-roles\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Patch.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump({\n   \"userIds\": [],\n   \"userRoles\": \"{\\\"tenant-name-1\\\":{\\\"roleIds\\\":[\\\"catalog.mgmt\\\"],\\\"sites\\\":{\\\"example-site-name-1\\\":{\\\"roleIds\\\":[\\\"order.mgmt\\\"]},\\\"example-site-name-2\\\":{\\\"roleIds\\\":[\\\"order.mgmt\\\"]}}},\\\"tenant-name-2\\\":{\\\"roleIds\\\":[\\\"user.mgmt\\\"],\\\"sites\\\":{\\\"example-site-name-1\\\":{\\\"roleIds\\\":[]},\\\"example-site-name-2\\\":{\\\"roleIds\\\":[\\\"inventory.mgmt\\\"]}}}}\"\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "BURpi62DsOZsWpHf9CoCl",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.upstartcommerce.com/v1/users/user-roles\"\n\npayload = json.dumps({\n   \"userIds\": [],\n   \"userRoles\": \"{\\\"tenant-name-1\\\":{\\\"roleIds\\\":[\\\"catalog.mgmt\\\"],\\\"sites\\\":{\\\"example-site-name-1\\\":{\\\"roleIds\\\":[\\\"order.mgmt\\\"]},\\\"example-site-name-2\\\":{\\\"roleIds\\\":[\\\"order.mgmt\\\"]}}},\\\"tenant-name-2\\\":{\\\"roleIds\\\":[\\\"user.mgmt\\\"],\\\"sites\\\":{\\\"example-site-name-1\\\":{\\\"roleIds\\\":[]},\\\"example-site-name-2\\\":{\\\"roleIds\\\":[\\\"inventory.mgmt\\\"]}}}}\"\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"PATCH\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "ZtWloQNEPoivn4N61lGxl"
    },
    "results": {
      "languages": [
        {
          "id": "EPZS0zhZj56Xw0ZUwRcgc",
          "language": "200",
          "code": "// All users' roles have been successfully updated.\n"
        },
        {
          "id": "coVXYcaEVCSrFlQFm7Dra",
          "language": "400",
          "code": "// The request contained information that the server was unable to process. Appropriate errors are provided in the response body.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": [\n    \"\"\n  ],\n  \"reason\": \"\"\n}"
        },
        {
          "id": "J0ZHHuYWBXmnCkvk0E8jL",
          "language": "401",
          "code": "// The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        },
        {
          "id": "3msz6fCRxdGcnkNQEUeUa",
          "language": "403",
          "code": "// An update to this resource requires the if-match and if-unmodified-since headers to be sent in order to process the request.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        },
        {
          "id": "VeBCc0v00FsCmkOWPz2jA",
          "language": "404",
          "code": "// The requested resource was not found in the NoChannel system.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        },
        {
          "id": "XSTXe6OZBDdDhqIdPrgaV",
          "language": "409",
          "code": "// The request conflicts with the current state of the resource.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        },
        {
          "id": "v1lxVYWbDsPPPaFYUDBaW",
          "language": "500",
          "code": "// Internal server error. The server encountered an unexpected condition that prevented it from fulfilling the request.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "EPZS0zhZj56Xw0ZUwRcgc"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}